function varargout=importdata_mod(varargin)
%importdata_mod2(file,mode=['defined','as_is'],ReplaceIfExistVariable=[default=true, false])
%      ,   
%    ;     
% 
% 1)   ,   data  
%     
% 2)       
%
%I. data=importdata_mod(file) =load(file),where file is a string whit full
% path to the text-file; all numeric data will be saved in  variable data
%
%II. importdata_mod(file,'as_is') variables will be saved to the base
% workspace with the original names from the text-file (data-output will be
% ignored)
%
%III. data=importdata_mod(file,'defined') all numeric data will be saved to the
%structure data with fields corresponding to the variables names from
%text-file
%IV. [a b c d]=importdata_mod(file,'defined') if you know how many variables are
%  in text file - columns will be saved to variables a b c d
% Modification by priester
% $Date: 2010/07/07 $



%% Testing input and output parameters

error(nargchk(1,3,nargin,'struct'));
rep_if_exist=true; 
mode='not_defined';
if nargin==2||nargin==3
    for k=2:length(varargin)
        if islogical(varargin{k})
           rep_if_exist=varargin{k};  
        end
        if ischar(varargin{k})
           mode=varargin{k};  
        end
    end
    
 switch  mode
     case 'as_is'
         
     case 'defined'
         if nargout==0
         error('Export type is "defined" - but no output variables set!');
         end
     otherwise
         error(['Wrong export parameter! (Wrong mode parameter: ' mode ')']);
 end
end %check input
% error(nargoutchk(0,1,nargout,'struct'));

% export_vars=varargin{2}; % 'names' - just export vars as simply new variables 
% to the base workspace; 'struct' - export vars as fields of data-structure

import_file=importdata(varargin{1}); % path to the text-file

%% case 1 simple data loading ignoring all comments;
if (nargout==1 && nargin==1)
    if isstruct(import_file)
    varargout{1}=import_file.data;  %ignoring all text-data, comments  
    else
    varargout{1}=import_file;   
    end  
return 
elseif (nargout==0 && nargin==1)
error('Specify output array!');       
end %=load()
 
%% 
% case 2 data loading and creation new variables with names from comments
% or as fields of data-structure
% or 
% working with textdata: find columns separated with ; or space

txt_data=import_file.textdata;
txt_data_nocomments=cell(1,1);
%ignorign all comments in txt_data
l=0;
[nrow ncol]=size(txt_data);
for n=1:nrow
    if ~( strcmpi(txt_data{n}(1),'%')||strcmpi(txt_data{n}(1),';')||strcmpi(txt_data{n}(1),'#') )
        
        if ~isempty(txt_data_nocomments{1})
        txt_data_nocomments=[txt_data_nocomments txt_data(n,:)]; %delete comments from txt_data
        else
        txt_data_nocomments=txt_data(n,:);    
        end
   end
end
txt_data=txt_data_nocomments;

if iscell(txt_data)
   if length(txt_data)==1 %textscan returned simple string
       
        vars_delim=textscan(txt_data{1},'%s','Delimiter',';'); %variables with description   
    
        if length(vars_delim{1})~=length(import_file.data(1,:)) %for spaced separeted variables names
        vars_delim=textscan(txt_data{1},'%s'); %variables with description  
        end
   nvars=length(vars_delim{1}); 
   vars_delim=vars_delim{1};
   elseif ( length(txt_data)==length(import_file.data(1,:)) ) %if textscan get right column names
   nvars=length(txt_data);
   vars_delim=cell(nvars,1);
   for n=1:nvars
   vars_delim{n}=txt_data{n}; 
   end
   else
   error(['Import error, check delimeters and column headers! ', ...
      'Column number in comments row and data row must be the same!']);
   end
  
end



%% build valid variable names (if delimeter ',' exist - ignore it)
var_name=cell(nvars,1);
for n=1:nvars
str_=textscan(vars_delim{n},'%s','Delimiter',','); %temporary string
var_name{n}=genvarname(str_{1} );
end

if ~rep_if_exist %Do Not replace variables - create numbered names
    for n=1:nvars    
        num=0;
        old_name=char(var_name{n});
        while  evalin('caller',['exist(''' char(var_name{n}) ''',''var'')']);
            num=num+1;
            var_name{n}=[];
            var_name{n}{1}=genvarname([old_name num2str(num)]);
        end
    end
end


switch      mode % export mode
    case   'as_is'
    if nargout>0
    error('For the case of "as_is" no output variables needed!')
    end
    for n=1:nvars 
    assignin('caller',  var_name{n}{1}, import_file.data(:,n))   
%     evalin('caller',[var_name{n}{1} '= import_file.data(:,n)']) ;
    end 
    
    case   'defined'
    for nout=1:nargout 
    varargout{nout}=import_file.data(:,nout);
    end 
    otherwise
    error('Test right input and output to the function, specify export parameter!');

end %end switch

end %end function





